﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.ComponentModel;
using System.Runtime.CompilerServices;
using System.Text;
using Telerik.XamarinForms.Chart;
using Xamarin.Forms;

namespace SlideViewXF
{
    public class ViewModel
    {
        public ViewModel()
        {
            MyItems = GetMockData();
        }
        public ObservableCollection<MyItem> MyItems { get; set; }

        private ObservableCollection<MyItem> GetMockData()
        {
            return new ObservableCollection<MyItem>
           {
              new MyItem
              {
                  Content = "Comm Fail",
                  ChartValue = "29%",
                  Data = new ObservableCollection<PieCategoricalData>  {
                         new PieCategoricalData { Category = "A", Value = 71 },
                         new PieCategoricalData { Category = "B", Value = 29 }
                  },
                  ChartPalette = GetPalettes("#FFC706"),
                  
               },
               new MyItem
               {
                   Content = "Flash",
                   ChartValue = "8%",
                   Data = new ObservableCollection<PieCategoricalData>  {
                       new PieCategoricalData { Category = "A", Value = 92 },
                       new PieCategoricalData { Category = "B", Value = 8 }
                    },
                   ChartPalette = GetPalettes("#E94135"),
                   
               },
               new MyItem
               {
                   Content = "Conflict",
                   ChartValue = "1%",
                   Data = new ObservableCollection<PieCategoricalData>  {
                       new PieCategoricalData { Category = "A", Value = 99 },
                       new PieCategoricalData { Category = "B", Value = 1 }
                   },
                   ChartPalette = GetPalettes("#384CA9"),
                   
               },
               new MyItem
               {
                   Content = "Disabled",
                   ChartValue = "2%",
                   Data = new ObservableCollection<PieCategoricalData>  {
                       new PieCategoricalData { Category = "A", Value = 98 },
                       new PieCategoricalData { Category = "B", Value = 2 }
                   },
                   ChartPalette = GetPalettes("#384CA9"),
                   
               },
               new MyItem
               {
                   Content = "Police Flash",
                   ChartValue = "0%",
                   Data = new ObservableCollection<PieCategoricalData>  {
                       new PieCategoricalData { Category = "A", Value = 100 },
                       new PieCategoricalData { Category = "B", Value = 0 }
                   },
                   ChartPalette = GetPalettes("#624698"),
                   
               }
           };
        }

        private ChartPalette GetPalettes(string colorHexValue)
       {
           ChartPalette palette = new ChartPalette();
 
           palette.Entries.Add(new PaletteEntry()
           { FillColor = Color.Yellow, StrokeColor = Color.Green});
           palette.Entries.Add(new PaletteEntry()
           { FillColor = Color.FromHex(colorHexValue), StrokeColor = Color.Black});
 
           return palette;
       }
    }

    public class MyItem
    {
       public string Content { get; set; }
       public string ChartValue { get; set; }
 
       public ChartPalette ChartPalette { get; set; }
 
       public ObservableCollection<PieCategoricalData> Data { get; set; }

        
   }

    public class PieCategoricalData : INotifyPropertyChanged
    {
        private object category;
        private double value;

        public object Category
        {
            get
            {
                return this.category;
            }
            set
            {
                if (this.category != value)
                {
                    this.category = value;
                    this.NotifyPropertyChanged("Category");
                }
            }
        }

        public double Value
        {
            get
            {
                return this.value;
            }
            set
            {
                if (this.value != value)
                {
                    this.value = value;
                    this.NotifyPropertyChanged("Value");
                }
            }
        }

        public event PropertyChangedEventHandler PropertyChanged;

        private void NotifyPropertyChanged([CallerMemberName] String propertyName = "")
        {
            if (PropertyChanged != null)
            {
                PropertyChanged(this, new PropertyChangedEventArgs(propertyName));
            }
        }
    }
       
}
